Index: qPloneSkinDump/trunk/Extensions/Install.py
===================================================================
--- qPloneSkinDump/trunk/Extensions/Install.py	(revision 72)
+++ qPloneSkinDump/trunk/Extensions/Install.py	(revision 74)
@@ -1,5 +1,8 @@
 from Products.Archetypes.Extensions.utils import install_subskin
-from Products.CMFCore.CMFCorePermissions import ManagePortal
 from Products.CMFCore.utils import getToolByName
+try:
+    from Products.CMFCore.permissions import ManagePortal
+except:
+    from Products.CMFCore.CMFCorePermissions import ManagePortal
 
 from Products.qPloneSkinDump.config import *
Index: qPloneSkinDump/trunk/config.py
===================================================================
--- qPloneSkinDump/trunk/config.py	(revision 72)
+++ qPloneSkinDump/trunk/config.py	(revision 74)
@@ -1,12 +1,12 @@
 import re, os
 try:
-    from Products.CMFCore import CMFCorePermissions
-except ImportError:
-    from Products.CMFCore import permissions as CMFCorePermissions
+    from Products.CMFCore import permissions
+except:
+    from Products.CMFCore import CMFCorePermissions as permissions
 
 ## Base Product Constants
 GLOBALS = globals()
 PROJECTNAME = "qPloneSkinDump"
-ADD_CONTENT_PERMISSION = CMFCorePermissions.AddPortalContent
+ADD_CONTENT_PERMISSION = permissions.AddPortalContent
 CONFIGURATION_CONFIGLET = "qploneskindump_configuration"
 
@@ -27,5 +27,5 @@
 DEFAULT_IMPORTING_POLICY = "only_new"
 FORBIDDEN_EXP_PREFIXES = re.compile('^(portal_)')
-FORBIDDEN_EXP_NAMES = ["MailHost", "HTTPCache", "Members", "RAMCache", "acl_users",\
+FORBIDDEN_EXP_NAMES = ["ResourceRegistryCache", "MailHost", "HTTPCache", "Members", "RAMCache", "acl_users",\
                        "archetype_tool", "caching_policy_manager", "content_type_registry", \
                        "cookie_authentication", "error_log", "kupu_library_tool",\
Index: qPloneSkinDump/trunk/configure.zcml
===================================================================
--- qPloneSkinDump/trunk/configure.zcml	(revision 74)
+++ qPloneSkinDump/trunk/configure.zcml	(revision 74)
@@ -0,0 +1,3 @@
+<configure xmlns="http://namespaces.zope.org/zope">
+
+</configure>
Index: qPloneSkinDump/trunk/exportingObjects.py
===================================================================
--- qPloneSkinDump/trunk/exportingObjects.py	(revision 72)
+++ qPloneSkinDump/trunk/exportingObjects.py	(revision 74)
@@ -6,4 +6,5 @@
 import os, os.path
 osp = os.path
+from config import PRODUCTS_PATH
 
 def copyFile(src_dir, dst_dir, f_name):
@@ -33,10 +34,11 @@
 ##                         EXPORTING                         ##
 ###############################################################
-def exportObjects(context, doesExportObjects, exporting_objects, product_name):
+def exportObjects(context, doesExportObjects, exporting_objects,
+                  fs_dest_directory, product_name):
     # Check whether should perform exporting
     if not doesExportObjects:
         return None
     # Get Instance's exported and Product's imoprt pathes
-    instance_epath, product_epath = getImportedPathes(product_name)
+    instance_epath, product_epath = getImportedPathes(fs_dest_directory, product_name)
     # Move same named files from Instance export dir to Temp dir
     temp_dir_path, product_elist = moveSameFilesToTemp(instance_epath, product_epath, exporting_objects)
@@ -62,9 +64,9 @@
     return fail_export
 
-def getImportedPathes(product_name):
+def getImportedPathes(fs_dest_directory, product_name):
     # Based on instance path, construct import pathes 
     cfg = getConfiguration()
     instance_epath = cfg.clienthome
-    product_epath = osp.join(cfg.instancehome, 'Products', product_name, "import")
+    product_epath = osp.join(fs_dest_directory, product_name, "import")
     # Check presence of Product import directory
     if not osp.isdir(product_epath):        
Index: qPloneSkinDump/trunk/qPloneSkinDump.py
===================================================================
--- qPloneSkinDump/trunk/qPloneSkinDump.py	(revision 72)
+++ qPloneSkinDump/trunk/qPloneSkinDump.py	(revision 74)
@@ -8,4 +8,8 @@
 
 security = ModuleSecurityInfo( 'Products.qPloneSkinDump.qPloneSkinDump' )
+
+security.declarePublic('getProductsPath')
+def getProductsPath():
+    return PRODUCTS_PATH
 
 security.declarePublic('getExportingData')
@@ -35,8 +39,17 @@
 
 security.declarePublic('isValidProductName')
-def isValidProductName(product_name):
+def isValidProductName(product_name, fs_dest_directory):
     """ Check for product presence in installed products list"""
-    return (product_name not in get_product_listdirs() \
-            and isValidDirName(product_name))
+    if not fs_dest_directory==PRODUCTS_PATH:
+       return (not product_name in os.listdir(fs_dest_directory)) \
+              and isValidDirName(product_name)
+
+    return (not product_name in get_product_listdirs()) \
+           and isValidDirName(product_name)
+
+security.declarePublic('isValidDestinationDir')
+def isValidDestinationDir(destination_dir):
+    """ Check for existance of destination directory."""
+    return os.path.isdir(destination_dir)
 
 DIR_NAME_PATTERN = re.compile("^[a-zA-Z]+[a-zA-Z0-9_]*[a-zA-Z0-9]$")
@@ -49,7 +62,8 @@
 security.declarePublic('createProduct')
 def createProduct(context, \
-                  zmi_skin_name='custom', \
+                  zmi_skin_names=['custom',], \
                   zmi_base_skin_name='', \
                   subdir=None,\
+                  fs_dest_directory=PRODUCTS_PATH, \
                   fs_skin_directory='custom',\
                   fs_product_name='QSkinTemplate',\
@@ -64,14 +78,17 @@
                   exporting_objects=[], \
                   dump_CSS=True, \
-                  dump_JS=True ):
+                  dump_JS=True, \
+                  dump_portlets=0, \
+                  dump_policy='root', \
+                  dump_portlets_selection=[], \
+                  dump_custom_views=False):
     """ Main Skin Product creating procedure."""
-    makeNewProduct(context, fs_product_name, fs_skin_directory, \
-                   zmi_skin_name, zmi_base_skin_name, subdir, \
+    makeNewProduct(context, fs_dest_directory, fs_product_name, fs_skin_directory, \
+                   zmi_skin_names, zmi_base_skin_name, subdir, \
                    doesCustomizeSlots, left_slots, right_slots, slot_forming, main_column, \
                    doesExportObjects, import_policy, \
-                   dump_CSS, dump_JS )
-    dumpSkin(context, zmi_skin_name, subdir, fs_skin_directory.lower(),
-             fs_product_name, erase_from_skin)
-    result = exportObjects(context, doesExportObjects, exporting_objects, fs_product_name)
+                   dump_CSS, dump_JS, dump_portlets, dump_policy, dump_portlets_selection, dump_custom_views)
+    dumpSkin(context, zmi_skin_names, fs_dest_directory, fs_product_name, erase_from_skin)
+    result = exportObjects(context, doesExportObjects, exporting_objects, fs_dest_directory, fs_product_name)
     return result
 
Index: qPloneSkinDump/trunk/skin_template/Extensions/Install.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/Extensions/Install.py	(revision 72)
+++ qPloneSkinDump/trunk/skin_template/Extensions/Install.py	(revision 74)
@@ -1,126 +1,25 @@
-import string
-from StringIO import StringIO
-from zLOG import LOG, INFO
 from Products.CMFCore.utils import getToolByName
-from Products.%(SKIN_PRODUCT_NAME)s.config import *
-from Products.%(SKIN_PRODUCT_NAME)s.Extensions.utils import *
 
-CHECKED_MESSAGE = "The base installation checkings completed."
+from Products.%(product_name)s.config import GS_INSTALL_PROFILE
+from Products.%(product_name)s.config import GS_AFTERINSTALL_PROFILE
+from Products.%(product_name)s.config import GS_UNINSTALL_PROFILE
 
-def prepareInstallation(portal, pp, product, out):
-    checkSuccessInstall(product)
-    uninstallOtherSkinProducts(portal)
-    if not ('uninstall_properties' in pp.objectIds()) :
-        pp.addPropertySheet(id='uninstall_properties', title= 'uninstall_properties')
-        print >> out, "Created 'portal_properties.uninstall_properties' PropertySheet (UP) for backup purpose"
+def install(self, reinstall=False):
+    """ Install skin with GenericSetup install profile
+    """
+    ps = getToolByName(self, 'portal_setup')
+    (ps.aq_base).__of__(self).runAllImportStepsFromProfile(GS_INSTALL_PROFILE)
 
-def checkSuccessInstall(product):
-    # Check for successfully completed 1 installation step
-    transcript = getattr(product,'transcript',None)
-    if transcript:
-        msg = str(transcript[0]['msg'])
-        if msg.find(CHECKED_MESSAGE) < 0 :
-            product.log("First part installation procedure not completed - installation terminated.")
-            raise
+def afterInstall(self, reinstall, product):
+    """ Install zexp objects and other dependent objects.
+        Perform this step here for prevent removing objects on uninstallation.
+    """
+    ps = getToolByName(self, 'portal_setup')
+    (ps.aq_base).__of__(self).runAllImportStepsFromProfile(GS_AFTERINSTALL_PROFILE)
 
-def uninstallOtherSkinProducts(portal):
-    qi=getToolByName(portal, 'portal_quickinstaller', None)
-    if not qi:
-        raise Exception("Can't work without QuickInstaller tool.")
-    # Get installed products
-    installed_products = [getattr(qi, p_dict['id']) \
-                          for p_dict in qi.listInstalledProducts()
-                          if p_dict['id'] != PRODUCT_NAME]
-    seek_str = "%%s generated product" %% GENERATOR_PRODUCT
-    installed_skin_products = []
-    # Looking for installed skin-products
-    for p in installed_products:
-        transcript = p.getTranscriptAsText()
-        if transcript.find(seek_str) >= 0 :
-            installed_skin_products.append(p.getId())
-    # Uninstall found skin-products
-    if installed_skin_products:
-        qi.uninstallProducts(products=installed_skin_products)
-
-def install(self):
-    # Checking base condition for installation
-    skinsTool = getToolByName(self, 'portal_skins')
-    # Checking for BASE_SKIN_NAME presenting in portal
-    skin_names = skinsTool.getSkinSelections()
-    if not BASE_SKIN_NAME in skin_names:
-        raise AttributeError("Impossible installation without %%s skin." %% BASE_SKIN_NAME)
-    # Checking for presenting lower_SKIN_NAME directory in portal skins
-    lower_SKIN_NAME = string.lower(SKIN_NAME)
-    if lower_SKIN_NAME in skinsTool.objectIds():
-        raise AttributeError("%%s skin layer already exist in portal skins. Installation Impossible." %% lower_SKIN_NAME)
-    return CHECKED_MESSAGE
-
-# For prevent quickInstaller's intervention in uninstall process - use afterInstall
-def afterInstall(self,product,reinstall):
-    out=StringIO()
-    # get all needed tools and some portal's core objects
-    portal = getToolByName(self, 'portal_url').getPortalObject()
-    pp = getToolByName(portal, 'portal_properties')
-    portal_css = getToolByName(portal, 'portal_css', None)
-    portal_js = getToolByName(portal, 'portal_javascripts', None)
-    # Make main prepare procedures
-    prepareInstallation(portal, pp, product, out)
-    pp_up = pp.uninstall_properties
-    # Install skin
-    installSkin(portal, pp_up, out)
-    # Register css resources
-    if portal_css and DOES_COSTOMIZE_CSS:
-        registerResource(pp_up, portal_css, portal_css.registerStylesheet, out \
-                        ,CSS_LIST, SKIN_CSS_REGDATA, 'q_registered_css', CSS_REG_PROPS)
-        print >> out, "Completed tuning CSS registry for new skin needs."
-    # Register js resources
-    if portal_js and DOES_COSTOMIZE_JS:
-        registerResource(pp_up, portal_js, portal_js.registerScript, out \
-                        ,JS_LIST, SKIN_JS_REGDATA, 'q_registered_js', JS_REG_PROPS)#---installJS---
-        print >> out, "Completed tuning JS registry for new skin needs."
-    # Customize slots    
-    if LEFT_SLOTS or RIGHT_SLOTS:
-        customizeSlots(portal, pp_up, out)
-    # Import object(s) to portal
-    if checkIfImport():
-        res_import = performImportToPortal(portal)
-        print >> out, res_import
-    # FINAL customization call additional functions from config 
-    if FINAL_CUSTOMIZATION_FUNCTIONS:
-        dummy = [func(portal, out) for func in FINAL_CUSTOMIZATION_FUNCTIONS]
-    print >> out, "%%s generated product." %% GENERATOR_PRODUCT
-    print >> out, '=== Installation successfully completed. ==='
-    product.log(out.getvalue())
-    product._p_changed = 1 #XXX:NEED for stable writing 'out' log to qi on afterinstallation.
-    return out.getvalue()
-
-def uninstall(self):
-    # get all needed tools and some portal's core objects
-    portal = self.portal_url.getPortalObject()
-    skinsTool = getToolByName(portal, 'portal_skins')
-    pp = getToolByName(portal, 'portal_properties')
-    portal_css = getToolByName(portal, 'portal_css', None)
-    portal_js = getToolByName(portal, 'portal_javascripts', None)
-    # Get all properies, saving during installation, for uninstalling
-    actual_skin_name = getProperty(pp, 'uninstall_properties', 'q_actual_skin_name',default=SKIN_NAME)
-    initial_skin = getProperty(pp, 'uninstall_properties', 'q_default_skin',default="")
-    original_css_list = getProperty(pp, 'uninstall_properties', 'q_registered_css')
-    original_js_list = getProperty(pp, 'uninstall_properties', 'q_registered_js')
-    orig_left_slots = getProperty(pp, 'uninstall_properties','q_left_slots')
-    orig_right_slots = getProperty(pp, 'uninstall_properties','q_right_slots')
-    # Remove 'uninstall_properties' from portal_properties
-    if 'uninstall_properties' in pp.objectIds() :
-        pp.manage_delObjects(ids=['uninstall_properties',])
-    # Uninstall skin
-    uninstallSkin(skinsTool, actual_skin_name, initial_skin)
-    # Unregister skin's CSS-es from portal_css. Only for Plone 2.1+
-    if portal_css and DOES_COSTOMIZE_CSS:
-        uninstallResource(portal_css, original_css_list, CSS_LIST, portal_css.registerStylesheet)
-    # Unregister skin's JS-s from portal_javascripts. Only for Plone 2.1+
-    if portal_js and DOES_COSTOMIZE_JS:
-        uninstallResource(portal_js, original_js_list, JS_LIST, portal_js.registerScript)
-    # Return site's column slots list unless Skin product installation
-    if orig_left_slots:
-        portal.left_slots = tuple(orig_left_slots)
-    if orig_right_slots:
-        portal.right_slots = tuple(orig_right_slots)
+def uninstall(self, reinstall=False):
+    """ Uninstall skin with GenericSetup uninstall profile
+    """
+    ps = getToolByName(self, 'portal_setup')
+    (ps.aq_base).__of__(self).runAllImportStepsFromProfile(GS_UNINSTALL_PROFILE)
+    
Index: qPloneSkinDump/trunk/skin_template/Extensions/__init__.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/Extensions/__init__.py	(revision 72)
+++ qPloneSkinDump/trunk/skin_template/Extensions/__init__.py	(revision 74)
@@ -1,2 +1,1 @@
-# this file is here to make Install.py importable.
-# we need to make it non-zero size to make winzip cooperate
+#
Index: qPloneSkinDump/trunk/skin_template/__init__.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/__init__.py	(revision 72)
+++ qPloneSkinDump/trunk/skin_template/__init__.py	(revision 74)
@@ -1,4 +1,1 @@
-from Products.CMFCore.DirectoryView import registerDirectory
-from config import GLOBALS
-
-registerDirectory('skins', GLOBALS)
+#
Index: qPloneSkinDump/trunk/skin_template/browser/__init__.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/browser/__init__.py	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/browser/__init__.py	(revision 74)
@@ -0,0 +1,1 @@
+#
Index: qPloneSkinDump/trunk/skin_template/browser/configure.zcml
===================================================================
--- qPloneSkinDump/trunk/skin_template/browser/configure.zcml	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/browser/configure.zcml	(revision 74)
@@ -0,0 +1,14 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:browser="http://namespaces.zope.org/browser"
+    i18n_domain="custom_i18n_domain">
+
+    <interface
+        interface=".interfaces.ITheme%(skin_name_capital)s"
+        type="zope.publisher.interfaces.browser.IBrowserSkinType"
+        name="%(skin_name)s"
+        />
+
+    <include file="viewlets.zcml"/>
+
+</configure>
Index: qPloneSkinDump/trunk/skin_template/browser/interfaces.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/browser/interfaces.py	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/browser/interfaces.py	(revision 74)
@@ -0,0 +1,5 @@
+from plone.theme.interfaces import IDefaultPloneLayer
+
+class ITheme%(skin_name_capital)s(IDefaultPloneLayer):
+    """Marker interface that defines a Zope 3 skin layer.
+    """
Index: qPloneSkinDump/trunk/skin_template/browser/viewlets.zcml
===================================================================
--- qPloneSkinDump/trunk/skin_template/browser/viewlets.zcml	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/browser/viewlets.zcml	(revision 74)
@@ -0,0 +1,8 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:browser="http://namespaces.zope.org/browser"
+    i18n_domain="custom_i18n_domain">
+
+    %(viewlets_zcml)s
+
+</configure>
Index: qPloneSkinDump/trunk/skin_template/config.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/config.py	(revision 72)
+++ qPloneSkinDump/trunk/skin_template/config.py	(revision 74)
@@ -1,2 +1,3 @@
+import os
 ## PLONE AND SKIN PRODUCT SPECIFIC CONSTANTS
 GLOBALS = globals()
@@ -14,6 +15,6 @@
 ## ['some/portlet1','some/portlet2'] - will change appropriate (left or right)
 ##                                     slot to listed portlets
-LEFT_SLOTS = %(LEFT_SLOTS)s
-RIGHT_SLOTS = %(RIGHT_SLOTS)s
+#LEFT_SLOTS = %(LEFT_SLOTS)s
+#RIGHT_SLOTS = %(RIGHT_SLOTS)s
 
 ## Slot's list forming procedure.
@@ -24,5 +25,5 @@
 #SLOT_FORMING = "blend_with_site"
 #SLOT_FORMING = "replace"
-SLOT_FORMING = "%(SLOT_FORMING)s"
+#SLOT_FORMING = "%(SLOT_FORMING)s"
 
 ## Favour column for slots forming procedure. IMPORTANT only for 'Blend with...' 
@@ -37,5 +38,5 @@
 #MAIN_COLUMN = "right"
 #MAIN_COLUMN = "both"
-MAIN_COLUMN = "%(MAIN_COLUMN)s"
+#MAIN_COLUMN = "%(MAIN_COLUMN)s"
 
 
@@ -100,2 +101,17 @@
 from Products.CMFCore.utils import getToolByName
 FINAL_CUSTOMIZATION_FUNCTIONS = []
+
+# site portlets registry
+SLOT_STRUCTURE = %(slot_structure)s
+
+# portal_view_customization content
+CUSTOM_VIEWS = %(custom_views)s
+
+# absolute file system path to product
+from Globals import package_home
+PRODUCTS_PATH = os.sep.join(package_home(GLOBALS).split(os.sep)[:-1])
+
+## GenericSetup constants
+GS_INSTALL_PROFILE      = "profile-Products.%(product_name)s:default"
+GS_AFTERINSTALL_PROFILE = "profile-Products.%(product_name)s:afterinstall"
+GS_UNINSTALL_PROFILE    = "profile-Products.%(product_name)s:uninstall"
Index: qPloneSkinDump/trunk/skin_template/configure.zcml
===================================================================
--- qPloneSkinDump/trunk/skin_template/configure.zcml	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/configure.zcml	(revision 74)
@@ -0,0 +1,12 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:cmf="http://namespaces.zope.org/cmf"
+    i18n_domain="%(product_name_lowercase)s">
+
+ <include file="profiles.zcml" />
+
+ <include file="skins.zcml" />
+
+ <include package=".browser" />
+
+</configure>
Index: qPloneSkinDump/trunk/skin_template/fixes.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/fixes.py	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/fixes.py	(revision 74)
@@ -0,0 +1,55 @@
+from Acquisition import aq_base
+from Products.CMFCore.utils import getToolByName
+from Products.ZCatalog.ProgressHandler import ZLogHandler
+from plone.app.linkintegrity.handlers import referencedRelationship as li_relation
+
+portal_catalog = None
+portal_repository = None
+uid_catalog = None
+reference_catalog = None
+
+def fix_archivest(ob):
+    ''' Fix #7334 bug of CMFEdition.
+        Fixed in CMFEdition v1.1.5+
+    '''
+    if portal_repository.isVersionable(ob):
+        portal_repository.save(obj=ob, comment="")
+
+def fix_catalog(ob):
+    ob.reindexObject()
+
+def fix_linkintegrity(ob):
+    """Fix losed references."""
+    uobject = aq_base(ob)
+    if reference_catalog.isReferenceable(uobject):
+        ob_li_refs = reference_catalog.getReferences(ob, relationship=li_relation)
+        if ob_li_refs:
+            annotations = ob._getReferenceAnnotations()
+            uniqueUIDs = uid_catalog.uniqueValuesFor('UID')
+            # delete references to non-existent objects
+            [annotations._delObject(ref.id) for ref in ob_li_refs \
+             if not ref.targetUID in uniqueUIDs]
+        
+def fix_all(ob):
+    """ Recursive function for perform registered
+        actions for all internal objects
+    """
+    [a(ob) for a in perobject_actions]
+
+    if getattr(ob, 'is_folderish', None):
+        [fix_all(o) for o in ob.objectValues()]
+
+perobject_actions = [fix_archivest, fix_catalog, fix_linkintegrity]
+
+def fix(context):
+    ''' Main fix function: fix defects of importing:
+        imported objects - absence in catalogs, some other issues'''
+    global portal_repository, portal_catalog
+    global uid_catalog, reference_catalog
+    portal_catalog = getToolByName(context,'portal_catalog')
+    portal_repository = getToolByName(context,'portal_repository')
+    uid_catalog = getToolByName(context,'uid_catalog')
+    reference_catalog = getToolByName(context,'reference_catalog')
+
+    fix_all(context)
+
Index: qPloneSkinDump/trunk/skin_template/profiles.zcml
===================================================================
--- qPloneSkinDump/trunk/skin_template/profiles.zcml	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/profiles.zcml	(revision 74)
@@ -0,0 +1,30 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:genericsetup="http://namespaces.zope.org/genericsetup"
+    i18n_domain="%(product_name_lowercase)s">
+
+  <genericsetup:registerProfile
+      name="default"
+      title="%(product_name)s"
+      directory="profiles/default"
+      description="Extension profile for %(product_name)s."
+      provides="Products.GenericSetup.interfaces.EXTENSION"
+      />
+
+  <genericsetup:registerProfile
+      name="afterinstall"
+      title="%(product_name)s:afterinstall"
+      directory="profiles/afterinstall"
+      description="Extension profile for install zexps and other dependent objects of %(product_name)s."
+      provides="Products.GenericSetup.interfaces.EXTENSION"
+      />
+
+  <genericsetup:registerProfile
+      name="uninstall"
+      title="%(product_name)s:uninstall"
+      directory="profiles/uninstall"
+      description="Extension profile for UNINSTALL %(product_name)s."
+      provides="Products.GenericSetup.interfaces.EXTENSION"
+      />
+
+</configure>
Index: qPloneSkinDump/trunk/skin_template/setuphandlers.py
===================================================================
--- qPloneSkinDump/trunk/skin_template/setuphandlers.py	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/setuphandlers.py	(revision 74)
@@ -0,0 +1,179 @@
+import sys
+from logging import getLogger
+
+from BTrees.OOBTree import OOBTree
+from persistent.list import PersistentList
+
+from zope.dottedname.resolve import resolve
+from zope.component import getUtility, getSiteManager, getMultiAdapter
+
+from plone.portlets.interfaces import IPortletAssignmentMapping, IPortletManager, IPlacelessPortletManager
+from plone.portlets.interfaces import IPortletContext, IPortletDataProvider
+from plone.portlets.interfaces import ILocalPortletAssignmentManager
+from plone.portlets.storage import PortletCategoryMapping, PortletAssignmentMapping
+from plone.app.portlets import portlets
+
+from plone.app.customerize.registration import *
+
+from Products.CMFCore.utils import getToolByName
+from Products.GenericSetup.utils import _getDottedName, _resolveDottedName
+
+from Products.%(product_name)s.config import *
+from Products.%(product_name)s.utils import *
+from Products.%(product_name)s.utilsPortlets import dumpPortlets
+
+logger = getLogger('%(product_name)s')
+
+def assignPortlet(mapping, info):
+    name = info['name']
+    try:
+        assignment = _resolveDottedName(info['class'])
+    except:
+        e,v,tr = sys.exc_info()
+        logger.info('Debug from setup portlets handler: %%s: %%s (%%s)' , info['class'], str(v), str(e))
+        return False
+    else:
+        portlet = assignment(**info['kwargs'])
+        if mapping.get(name, None) is not None:
+            del mapping[name]
+        mapping[name] = portlet
+        return portlet
+
+def setupSiteWidePortlets(site, data, managers):
+
+    for name, info in data:
+        manager = managers.get(name, None)
+        if manager is not None:
+            for category, keys in info.items():
+                catmapping = manager.get(category, None)
+                if catmapping is None:
+                    catmapping = manager[category] = PortletCategoryMapping()
+                for key, assignments in keys.items():
+                    mapping = catmapping.get(key, None)
+                    if mapping is None:
+                        mapping = catmapping[key] = PortletAssignmentMapping()
+                    for assignment in assignments.values():
+                        assignPortlet(mapping, assignment)
+
+def setupPortletsForContext(context, data, managers):
+
+    for name, info in data:
+        manager = managers.get(name, None)
+        if manager is not None:
+            # set portlet assignments
+            mapping = getMultiAdapter((context, manager), IPortletAssignmentMapping, context=context)
+
+            # purge mapping
+            mapping._data = OOBTree()
+            mapping._order = PersistentList()
+
+            if info['assignments']:
+                # set portlet assignments
+                for assignment in info['assignments']:
+                    assignPortlet(mapping, assignment)
+            if info['blacklists']:
+                # set blacklists
+                localassignmentmanager = getMultiAdapter((context, manager), ILocalPortletAssignmentManager, context=context)
+                for category, status in info['blacklists']:
+                    localassignmentmanager.setBlacklistStatus(category, status)
+
+
+def saveBeforeInstallPortlets(context):
+    # Save information about portlets before installation
+
+    beforeInstall = dumpPortlets(context=context, dump_policy='root', dump_portlets_selection=[] )
+
+    # update properties list
+    pp = getToolByName(context, 'portal_properties')
+    skin_props = pp._getOb('%(product_name_lowercase)s_properties')
+    skin_props._updateProperty('portlets_before_install', str(beforeInstall) )
+
+
+def importPortlets(context):
+
+    if context.readDataFile("%(afterinstall_profile_marker)s") is None:
+        return
+
+    site = context.getSite()
+
+    saveBeforeInstallPortlets(site)
+
+    components = getSiteManager(site)
+    ms = [r for r in components.registeredUtilities() if r.provided.isOrExtends(IPortletManager)]
+    context_managers = {}
+    for m in ms:
+        if not m.provided.isOrExtends(IPlacelessPortletManager):
+            context_managers[m.name] = getUtility(IPortletManager, name=m.name, context=site)
+
+    managers = {}
+    for m in ms:
+        managers[m.name] = getUtility(IPortletManager, name=m.name, context=site)
+
+    for path, info in SLOT_STRUCTURE:
+        if path == '__site-wide-portlets__':
+            setupSiteWidePortlets(site, info, managers)
+        else:
+            try:
+                obj = site.restrictedTraverse(path)
+            except:
+                e,v,tr = sys.exc_info()
+                logger.info('Debug from importPortlets handler: %%s: %%s (%%s)' , path, str(v), str(e))
+            else:
+                setupPortletsForContext(obj, info, context_managers)
+
+def importZexps(context):
+
+    if context.readDataFile("%(afterinstall_profile_marker)s") is None:
+        return
+
+    site = context.getSite()
+    if checkIfImport():
+        performImportToPortal(site)
+
+def importVarious(context):
+
+    if context.readDataFile("%(afterinstall_profile_marker)s") is None:
+        return
+
+    site = context.getSite()
+    out = StringIO()
+    if FINAL_CUSTOMIZATION_FUNCTIONS:
+        dummy = [func(site, out) for func in FINAL_CUSTOMIZATION_FUNCTIONS]
+
+def importCustomViews(context):
+
+    if context.readDataFile("%(afterinstall_profile_marker)s") is None:
+        return
+
+    site = context.getSite()
+
+    for view in CUSTOM_VIEWS:
+        for_name = view['for_name']
+        view_name = view['view_name']
+        type_name = view['type_name']
+        kwargs = view['kwargs']
+
+        reg = findTemplateViewRegistration(for_name, type_name, view_name)
+        viewzpt_id = str(generateIdFromRegistration(reg))
+
+        container = getUtility(IViewTemplateContainer)
+        if viewzpt_id in container.objectIds():
+            continue
+
+        attr, pt = findViewletTemplate(reg.factory)
+        if pt:
+            ptname = basename(pt.filename)
+        else:
+            ptname = None
+        viewzpt = TTWViewTemplate(
+            id = viewzpt_id,
+            text = kwargs['text'],
+            encoding = kwargs['encoding'],
+            content_type = kwargs['content_type'],
+            view = getViewClassFromRegistration(reg),
+            permission = getViewPermissionFromRegistration(reg),
+            name = ptname)
+        container.addTemplate(viewzpt_id, viewzpt)
+
+        sm = getSiteManager(site)
+        sm.registerAdapter(viewzpt, required = reg.required, provided = reg.provided, name = reg.name)
Index: qPloneSkinDump/trunk/skin_template/skins.zcml
===================================================================
--- qPloneSkinDump/trunk/skin_template/skins.zcml	(revision 74)
+++ qPloneSkinDump/trunk/skin_template/skins.zcml	(revision 74)
@@ -0,0 +1,8 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:cmf="http://namespaces.zope.org/cmf"
+    i18n_domain="%(product_name_lowercase)s">
+
+   <cmf:registerDirectory name="skins" directory="skins" recursive="True" />
+
+</configure>
